# cszone.tcl v1.0 by domsen <domsen@domsen.org> (c)2oo3
#
# comments? bugs? ideas? requests? money? beer?
# plz mail me or visit my homepage @ www.domsen.org
#
# das tcl liest die  csstrike-zone.de news aus und gibt sie wieder,  gleich mit
# dem link zum eigentlichen artikel. per trigger lassen sich auch die letzten X
#
# v1.0 - first public version
#
# cztrigger             - standardmig   auf  ".cszone"   gesetzt,  gibt die
#			  letzten 'cszonelimit' newslines wieder
# cszonelimit         - "" fr  unbegrenzte newslines, ansonsten eine zahl
# cznewspost            - 1 fr newsposting, 0 fr keines
# lanparychans          - die  chans in  denen das tcl aktiv  ist, wobei "" fr
#                         alle  steht,  ansonsten  einfach  "#chan1 #chan2" usw
# cszonenewspostlimit - verhindert ungewollte floods beim newsposten
# isczrhub  	        - legt fest ob der bot newshub ist oder nicht, das leaf
#                         tcl ist auch auf www.domsen.org verfgbar.
# czleafs               - die nicks der leafbots auf  denen das leaf tcl luft,
#		          "" fr keine, oder "botnick1 botnick2" usw
#
####### config ######################

set cztrigger ".cszone"
set cszonechans ""
set cszonelimit "10"
set cszonenewspostlimit "3"
set cznewspost "1"
set isczhub "0"
set czleafs ""
set greetmessage "hallo, tippe .cszone um die letzten news von www.cstrike-zone.de zu erhalten"

####### ende der config #############

bind msg - $cztrigger msg_cz
bind pub - $cztrigger pub_cz
bind time - "?* * * * *" czcheck
bind join - * greetmsg

proc greetmsg { nick uhost hand chan } {
global cszonechans greetmessage botnick
if {$nick == $botnick} { return 0}
if {([lsearch -exact [string tolower $cszonechans] [string tolower $chan]] != -1) || ($cszonechans == "")} { 
putserv "privmsg $chan :$greetmessage"
}}


proc sendcszonenews { arg } {
global czleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $czleafs] [string tolower $bot]] != -1)} {
putbot $bot "cszone: $arg"
}}}

proc shrink { calc number string start bl} { return [expr [string first "$string" $bl] $calc $number] }


proc czcheck {nick uhost hand chan arg} {
global cszonechans cznewspost isczhub cszonenewspostlimit
set counter 0
if {$cznewspost == 1 } {
putlog "cszone: suche nach neuer newsline"
set czlastnews "none"
if {[file exists cszone.hdl]} {
set temp [open "cszone.hdl" r]
set czlastnews "[gets $temp]"
close $temp
}
set temp [open "cszone.hdl" w+]
if {[catch {set sock [socket www.cstrike-zone.de 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /plain_news.php  HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: www.cstrike-zone.de"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "NewsID" $bl] != -1 } {
set link www.cstrike-zone.de/view.php?news=[string range $bl [shrink + 8 "NewsID: " 0 $bl] [shrink - 1 "<br>NewsTitel: " 0 $bl]]
set newsline [string range $bl [shrink + 11 "NewsTitel: " 0 $bl] [shrink - 1 "<br/>" 0 $bl]]
puts $temp "$newsline <$link>"
}}}
close $sock ; close $temp
if {$czlastnews == "none" } { putlog "cszone: headlinefile created" ; return 0 }
set temp [open "cszone.hdl" r]
putserv "privmsg $chan :Es gibt neue News auf www.Cstrike-Zone.de "
while { [eof $temp] != 1 } {
set czneunews [gets $temp]
if {($czlastnews == $czneunews) || ($counter == $cszonenewspostlimit) || ($czneunews == "")} { return 0 }
incr counter
if { $isczhub == "1" } { sendcszonenews $czneunews }
foreach chan [channels] {
if {$cszonechans == "" } { putserv "privmsg $chan :$czneunews" }
if {$cszonechans != "" } {
if {([lsearch -exact [string tolower $cszonechans] [string tolower $chan]] != -1) || ($cszonechans == "")} {putserv "privmsg $chan :(neue cszone newsline) $czneunews"}
}
}}}}


proc cszonenews { target limit } {
if {[catch {set sock [socket www.cstrike-zone.de 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /plain_news.php  HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: www.cstrike-zone.de"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
putserv "privmsg $target :Die aktuellsten $limit News auf www.cstrike-zone.de :"
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "NewsID" $bl] != -1 } {
set link www.cstrike-zone.de/view.php?news=[string range $bl [shrink + 8 "NewsID: " 0 $bl] [shrink - 1 "<br>NewsTitel: " 0 $bl]]
set newsline [string range $bl [shrink + 11 "NewsTitel: " 0 $bl] [shrink - 1 "<br/>" 0 $bl]]
putserv "privmsg $target :[incr counter] $newsline <$link>"
}
if {$counter == $limit} {close $sock ; return 0}
}}}


proc msg_cz { nick uhost hand arg } { global cszonelimit ; cszonenews $nick $cszonelimit }
proc pub_cz { nick uhost hand chan arg } { global cszonechans cszonelimit ; if {([lsearch -exact [string tolower $cszonechans] [string tolower $chan]] != -1) || ($cszonechans == "")} { cszonenews $nick $cszonelimit }}



putlog "*** cszone.tcl v1.0 by domsen <domsen@domsen.org> succesfully loaded"

#[EOF]







